Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/tracco2i_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/tracco2i_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/tracco2i_mod.F90	(revision 3605)
@@ -2,4 +2,13 @@
 !
 ! This module does the work for the interactive CO2 tracers
+! Authors: Patricia Cadule and Olivier Boucher
+!
+! Purpose and description:
+!  -----------------------
+! Main routine for the interactive carbon cycle
+! Gather all carbon fluxes and emissions from ORCHIDEE, PISCES and fossil fuel
+! Compute the net flux in source field which is used in phytrac
+! Compute global CO2 mixing ratio for radiation scheme if option is activated
+! Redistribute CO2 evenly over the atmosphere if transport is desactivated
 !
 CONTAINS
@@ -10,11 +19,18 @@
 
     USE dimphy
-    USE infotrac
-    USE geometry_mod, ONLY : cell_area
-    USE carbon_cycle_mod, ONLY : nbcf_in, fields_in, cfname_in, fco2_ocn_day, fco2_ff, fco2_bb
+    USE infotrac_phy
+    USE geometry_mod, ONLY: cell_area
+    USE carbon_cycle_mod, ONLY: carbon_cycle_init
+    USE carbon_cycle_mod, ONLY: id_CO2, nbcf_in, fields_in, cfname_in
+    USE carbon_cycle_mod, ONLY: fco2_ocn_day, fco2_ff, fco2_bb, fco2_land, fco2_ocean
+    USE carbon_cycle_mod, ONLY: fco2_land_nbp, fco2_land_nep, fco2_land_fLuc
+    USE carbon_cycle_mod, ONLY: fco2_land_fwoodharvest, fco2_land_fHarvest
+    USE carbon_cycle_mod, ONLY: carbon_cycle_cpl, carbon_cycle_tr, carbon_cycle_rad, RCO2_glo, RCO2_tot
     USE mod_grid_phy_lmdz
-    USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
+    USE mod_phys_lmdz_mpi_data, ONLY: is_mpi_root
     USE mod_phys_lmdz_para, ONLY: gather, bcast, scatter
     USE phys_cal_mod
+    USE phys_state_var_mod, ONLY: pctsrf
+    USE indice_sol_mod, ONLY: nbsrf, is_ter, is_lic, is_oce, is_sic
 
     IMPLICIT NONE
@@ -45,17 +61,13 @@
 !----------------
 
-    INTEGER, PARAMETER :: id_CO2=1              !--temporaire OB -- to be changed 
     INTEGER                        :: it, k, i, nb
     REAL, DIMENSION(klon,klev)     :: m_air     ! mass of air in every grid box [kg]
-    REAL, DIMENSION(klon)          :: co2land   ! surface land CO2 emissions [kg CO2/m2/s]
-    REAL, DIMENSION(klon)          :: co2ocean  ! surface ocean CO2 emissions [kg CO2/m2/s]
     REAL, DIMENSION(klon_glo,klev) :: co2_glo   ! variable temporaire sur la grille global
     REAL, DIMENSION(klon_glo,klev) :: m_air_glo ! variable temporaire sur la grille global
 
-
-    INTEGER, SAVE :: mth_pre=0
-!$OMP THREADPRIVATE(mth_pre)
-    REAL, SAVE :: RCO2_glo
-!$OMP THREADPRIVATE(RCO2_glo)
+    LOGICAL, SAVE :: check_fCO2_nbp_in_cfname
+!$OMP THREADPRIVATE(check_fCO2_nbp_in_cfname)
+    INTEGER, SAVE :: day_pre=-1
+!$OMP THREADPRIVATE(day_pre)
 
     IF (is_mpi_root) THEN
@@ -67,7 +79,21 @@
 !--convert 280 ppm into kg CO2 / kg air
     IF (debutphy) THEN
+
+! Initialisation de module carbon_cycle_mod
+      IF (carbon_cycle_cpl) THEN
+        CALL carbon_cycle_init()
+      ENDIF
+
+! Initialisation de tr_seri(id_CO2) si pas initialise
       IF (MAXVAL(tr_seri(:,:,id_CO2)).LT.1.e-15) THEN 
-        tr_seri(:,:,id_CO2)=280.e-6/RMD*RMCO2
+        tr_seri(:,:,id_CO2)=co2_ppm0*1.e-6/RMD*RMCO2 !--initialised from co2_ppm0 in rdem
       ENDIF 
+
+!--check if fCO2_nbp is in 
+      check_fCO2_nbp_in_cfname=.FALSE.
+      DO nb=1, nbcf_in
+        IF (cfname_in(nb)=="fCO2_nbp") check_fCO2_nbp_in_cfname=.TRUE.
+      ENDDO
+
     ENDIF
 
@@ -85,32 +111,82 @@
 
 !--retrieving land and ocean CO2 flux
-!--fCO2_nep comes in unit of g CO2 m-2 dt_stomate-1 
-!--this needs to be changed in ORCHIDEE
-    co2land(:)=0.0
-    co2ocean(:)=0.0
+    fco2_land(:)=0.0
+    fco2_ocean(:)=0.0
+    fco2_land_nbp(:)=0.
+    fco2_land_nep(:)=0.
+    fco2_land_fLuc(:)=0.
+    fco2_land_fwoodharvest(:)=0.
+    fco2_land_fHarvest(:)=0.
+
     DO nb=1, nbcf_in
-      IF (cfname_in(nb) == "fCO2_nep" )   co2land(:)=fields_in(:,nb)*RMCO2/RMC/86400./1000.
-      !!IF (cfname_in(nb) == "fCO2_fgco2" ) co2ocean(:)=fco2_ocn_day(:) !--for now
+
+      SELECT CASE(cfname_in(nb))
+!--dealing with the different fluxes coming from ORCHIDEE
+!--fluxes come in unit of kg C m-2 s-1 is converted into kg CO2 m-2 s-1
+      CASE("fCO2_nep")
+          fco2_land_nep(:)=fields_in(:,nb)*RMCO2/RMC*pctsrf(:,is_ter)
+      CASE("fCO2_fLuc")
+          fco2_land_fLuc(:)=fields_in(:,nb)*RMCO2/RMC*pctsrf(:,is_ter)
+      CASE("fCO2_fwoodharvest")
+          fco2_land_fwoodharvest(:)=fields_in(:,nb)*RMCO2/RMC*pctsrf(:,is_ter)
+      CASE("fCO2_fHarvest")
+          fco2_land_fHarvest(:)=fields_in(:,nb)*RMCO2/RMC*pctsrf(:,is_ter)
+      CASE("fCO2_nbp")
+          fco2_land_nbp(:)=fields_in(:,nb)*RMCO2/RMC*pctsrf(:,is_ter)
+!--fCO2_fco2_ocn comes in unit of mol C02 m-2 s-1 is converted into kg CO2 m-2 s-1 + change sign
+      CASE("fCO2_fgco2") 
+          fco2_ocean(:)=-1.*fco2_ocn_day(:)*RMCO2/1.e3*(pctsrf(:,is_oce)+pctsrf(:,is_sic))
+      END SELECT
+
     ENDDO
 
-!--preparing the net anthropogenic flux at the surface for mixing layer 
-!--unit kg CO2 / m2 / s
-    source(:,id_CO2)=fco2_ff(:)+fco2_bb(:)+co2land(:)+co2ocean(:)
+!--if fCO2_nbp is transferred we use it, otherwise we use the sum of what has been passed from ORCHIDEE
+    IF (check_fCO2_nbp_in_cfname)  THEN
+       fco2_land(:)=fco2_land_nbp(:)
+    ELSE
+       fco2_land(:)=fco2_land_nep(:)+fco2_land_fLuc(:)+fco2_land_fwoodharvest(:)+fco2_land_fHarvest(:)
+    ENDIF
+
+!!--preparing the net anthropogenic flux at the surface for mixing layer
+!!--unit kg CO2 / m2 / s
+!    PRINT *, 'tracco2i_mod.F90 --- MAXVAL(fco2_ff) ',MAXVAL(fco2_ff)
+!    PRINT *, 'tracco2i_mod.F90 --- MINVAL(fco2_ff) ',MINVAL(fco2_ff)
+!    PRINT *, 'tracco2i_mod.F90 --- MAXVAL(fco2_bb) ',MAXVAL(fco2_bb)
+!    PRINT *, 'tracco2i_mod.F90 --- MINVAL(fco2_bb) ',MINVAL(fco2_bb)
+!    PRINT *, 'tracco2i_mod.F90 --- MAXVAL(fco2_land) ',MAXVAL(fco2_land)
+!    PRINT *, 'tracco2i_mod.F90 --- MINVAL(fco2_land) ',MINVAL(fco2_land)
+!    PRINT *, 'tracco2i_mod.F90 --- MAXVAL(fco2_ocean) ',MAXVAL(fco2_ocean)
+!    PRINT *, 'tracco2i_mod.F90 --- MINVAL(fco2_ocean) ',MINVAL(fco2_ocean)
+!    PRINT *, 'tracco2i_mod.F90 --- MAXVAL(source(:,id_CO2)) ',MAXVAL(source(:,id_CO2))
+!    PRINT *, 'tracco2i_mod.F90 --- MINVAL(source(:,id_CO2)) ',MINVAL(source(:,id_CO2))
+!
+!--build final source term for CO2
+    source(:,id_CO2)=fco2_ff(:)+fco2_bb(:)+fco2_land(:)+fco2_ocean(:)
 
 !--computing global mean CO2 for radiation
-!--every timestep for now but enough every month
-!    IF (debutphy.OR.mth_cur.NE.mth_pre) THEN
+!--for every timestep comment out the IF ENDIF statements 
+!--otherwise this is updated every day
+    IF (debutphy.OR.day_cur.NE.day_pre) THEN
+
       CALL gather(tr_seri(:,:,id_CO2),co2_glo)
       CALL gather(m_air,m_air_glo)
+
 !$OMP MASTER
-!--conversion from kg CO2/kg air into ppm
+
+!--compute a global mean CO2 value and print its value in ppm
        IF (is_mpi_root) THEN
-         RCO2_glo=SUM(co2_glo*m_air_glo)/SUM(m_air_glo)*1.e6*RMD/RMCO2
+         RCO2_tot=SUM(co2_glo*m_air_glo)  !--unit kg CO2
+         RCO2_glo=RCO2_tot/SUM(m_air_glo) !--unit kg CO2 / kg air
+         PRINT *,'tracco2i: global CO2 in ppm =', RCO2_glo*1.e6*RMD/RMCO2
+         PRINT *,'tracco2i: total CO2 in kg =', RCO2_tot
        ENDIF
-       PRINT *,'toto in tracco2i: global CO2 in ppm =', RCO2_glo
 !$OMP END MASTER
        CALL bcast(RCO2_glo)
-       mth_pre=mth_cur
-!    ENDIF
+       day_pre=day_cur
+!--if not carbon_cycle_tr, then we reinitialize the CO2 each day to its global mean value
+       IF (.NOT.carbon_cycle_tr) THEN 
+         tr_seri(:,:,id_CO2)=RCO2_glo
+       ENDIF
+    ENDIF
 
   END SUBROUTINE tracco2i
@@ -119,5 +195,5 @@
 
     USE dimphy
-    USE infotrac
+    USE infotrac_phy
     USE geometry_mod, ONLY : cell_area
     USE mod_grid_phy_lmdz
@@ -129,5 +205,5 @@
     USE netcdf, ONLY: nf90_get_var, nf90_noerr, nf90_nowrite
 
-    USE carbon_cycle_mod, ONLY : fco2_ff, fco2_bb
+    USE carbon_cycle_mod, ONLY : fco2_ff, fco2_bb, fco2_land, fco2_ocean
 
     IMPLICIT NONE
@@ -150,5 +226,10 @@
 !! may be controlled via the .def later on
 !! also co2bb for now comes from ORCHIDEE
-    LOGICAL, PARAMETER :: readco2ff=.TRUE., readco2bb=.FALSE. 
+    LOGICAL, PARAMETER :: readco2ff=.TRUE.
+!! this should be left to FALSE for now
+    LOGICAL, PARAMETER :: readco2bb=.FALSE. 
+
+    CHARACTER (len = 20) :: modname = 'tracco2i.co2_emissions'
+    CHARACTER (len = 80) :: abort_message
 
     IF (debutphy) THEN 
@@ -173,6 +254,6 @@
         n_glo = size(vector)
         IF (n_glo.NE.klon_glo) THEN
-           PRINT *,'sflx_lmdz_co2_ff: le nombre de points n est pas egal a klon_glo'
-           STOP
+           abort_message='sflx_lmdz_co2_ff: le nombre de points n est pas egal a klon_glo'
+           CALL abort_physic(modname,abort_message,1)
         ENDIF
 
@@ -181,6 +262,6 @@
         n_month = size(time)
         IF (n_month.NE.12) THEN
-           PRINT *,'sflx_lmdz_co2_ff: le nombre de month n est pas egal a 12'
-           STOP
+           abort_message='sflx_lmdz_co2_ff: le nombre de month n est pas egal a 12'
+           CALL abort_physic(modname,abort_message,1)
         ENDIF
 
@@ -196,4 +277,5 @@
 
 !--reading CO2 biomass burning emissions
+!--using it will be inconsistent with treatment in ORCHIDEE
       IF (readco2bb) THEN 
 
@@ -205,6 +287,6 @@
       n_glo = size(vector)
       IF (n_glo.NE.klon_glo) THEN
-         PRINT *,'sflx_lmdz_co2_bb: le nombre de points n est pas egal a klon_glo'
-         STOP
+         abort_message='sflx_lmdz_co2_bb: le nombre de points n est pas egal a klon_glo'
+         CALL abort_physic(modname,abort_message,1)
       ENDIF
 
@@ -213,6 +295,6 @@
       n_month = size(time)
       IF (n_month.NE.12) THEN
-         PRINT *,'sflx_lmdz_co2_bb: le nombre de month n est pas egal a 12'
-         STOP
+         abort_message='sflx_lmdz_co2_bb: le nombre de month n est pas egal a 12'
+         CALL abort_physic(modname,abort_message,1)
       ENDIF
 
@@ -247,6 +329,5 @@
     PRINT *,'probleme avec le mois dans co2_ini =', mth_cur
   ENDIF
-  IF (.NOT.ALLOCATED(fco2_ff)) ALLOCATE(fco2_ff(klon))
-  IF (.NOT.ALLOCATED(fco2_bb)) ALLOCATE(fco2_bb(klon))
+
   fco2_ff(:) = flx_co2ff(:,mth_cur)
   fco2_bb(:) = flx_co2bb(:,mth_cur)
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/traclmdz_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/traclmdz_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/traclmdz_mod.F90	(revision 3605)
@@ -92,5 +92,4 @@
     USE regr_pr_comb_coefoz_m, ONLY: alloc_coefoz
     USE press_coefoz_m, ONLY: press_coefoz
-    USE carbon_cycle_mod, ONLY : carbon_cycle_init, carbon_cycle_tr, carbon_cycle_cpl
     USE mod_grid_phy_lmdz
     USE mod_phys_lmdz_para
@@ -285,10 +284,4 @@
 
 !
-! Initialisation de module carbon_cycle_mod
-! ----------------------------------------------
-    IF (carbon_cycle_tr .OR. carbon_cycle_cpl) THEN
-       CALL carbon_cycle_init(tr_seri, pdtphys, aerosol, radio)
-    END IF
-
 ! Check if all tracers have restart values
 ! ----------------------------------------------
@@ -346,5 +339,4 @@
     USE regr_pr_comb_coefoz_m, ONLY: regr_pr_comb_coefoz
     USE o3_chem_m, ONLY: o3_chem
-    USE carbon_cycle_mod, ONLY : carbon_cycle, carbon_cycle_tr, carbon_cycle_cpl
     USE indice_sol_mod
 
@@ -612,11 +604,4 @@
     END IF
 
-!======================================================================
-!   Calcul de cycle de carbon
-!======================================================================
-    IF (carbon_cycle_tr .OR. carbon_cycle_cpl) THEN
-       CALL carbon_cycle(nstep, pdtphys, pctsrf, tr_seri, source)
-    END IF
-
   END SUBROUTINE traclmdz
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/undefSTD.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/undefSTD.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/undefSTD.F90	(revision 3605)
@@ -43,5 +43,4 @@
   ! PARAMETER(klevSTD=17)
   INTEGER itap
-  ! REAL dtime
 
   ! variables locales
@@ -67,8 +66,8 @@
 
 
-    ! calcul variables tous les freq_calNMC(n)/dtime pas de temps
+    ! calcul variables tous les freq_calNMC(n)/phys_tstep pas de temps
     ! de la physique
 
-    IF (mod(itap,nint(freq_calnmc(n)/dtime))==0) THEN
+    IF (mod(itap,nint(freq_calnmc(n)/phys_tstep))==0) THEN
       DO k = 1, nlevstd
         DO i = 1, klon
@@ -103,5 +102,5 @@
       END DO !k
 
-    END IF !MOD(itap,NINT(freq_calNMC(n)/dtime)).EQ.0
+    END IF !MOD(itap,NINT(freq_calNMC(n)/phys_tstep)).EQ.0
 
   END DO !n
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/wake.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/wake.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/wake.F90	(revision 3605)
@@ -196,9 +196,12 @@
   INTEGER                                               :: nsub
   REAL                                                  :: dtimesub
-  REAL                                                  :: wdensmin
+  REAL, SAVE                                            :: wdensmin
+  !$OMP THREADPRIVATE(wdensmin)
   REAL, SAVE                                            :: sigmad, hwmin, wapecut, cstart
   !$OMP THREADPRIVATE(sigmad, hwmin, wapecut, cstart)
-  REAL                                                  :: sigmaw_max
-  REAL                                                  :: dens_rate
+  REAL, SAVE                                            :: sigmaw_max
+  !$OMP THREADPRIVATE(sigmaw_max)  
+  REAL, SAVE                                            :: dens_rate
+  !$OMP THREADPRIVATE(dens_rate)
   REAL                                                  :: wdens0
   ! IM 080208
@@ -1015,4 +1018,7 @@
 
     IF (iflag_wk_pop_dyn >= 1) THEN
+!    The variable "death_rate" is significant only when iflag_wk_pop_dyn = 0.
+!    Here, it has to be set to zero.
+      death_rate(:) = 0.
 
       IF (iflag_wk_act ==2) THEN
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/write_histrac.h
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/write_histrac.h	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/write_histrac.h	(revision 3605)
@@ -8,5 +8,5 @@
      
      CALL histwrite_phy(nid_tra,.FALSE.,"phis",itau_w,pphis)
-     CALL histwrite_phy(nid_tra,.FALSE.,"aire",itau_w,airephy)
+     CALL histwrite_phy(nid_tra,.FALSE.,"aire",itau_w,cell_area)
      CALL histwrite_phy(nid_tra,.FALSE.,"zmasse",itau_w,zmasse)
 ! RomP >>>
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/yamada4.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/yamada4.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/yamada4.F90	(revision 3605)
@@ -152,4 +152,7 @@
   !$OMP THREADPRIVATE(firstcall)
 
+  CHARACTER (len = 20) :: modname = 'yamada4'
+  CHARACTER (len = 80) :: abort_message
+
 
 
@@ -199,5 +202,5 @@
     ENDIF
 
-    PRINT*,'YAMADA4 RIc, RIfc, Sm_min, Alpha_min',ric,rifc,seuilsm,seuilalpha
+    WRITE(lunout,*)'YAMADA4 RIc, RIfc, Sm_min, Alpha_min',ric,rifc,seuilsm,seuilalpha
     firstcall = .FALSE.
     CALL getin_p('lmixmin',lmixmin)
@@ -216,5 +219,6 @@
 
   IF (.NOT. (iflag_pbl>=6 .AND. iflag_pbl<=12)) THEN
-    STOP 'probleme de coherence dans appel a MY'
+    abort_message='probleme de coherence dans appel a MY'
+    CALL abort_physic(modname,abort_message,1)
   END IF
 
@@ -537,5 +541,6 @@
 
   ELSE
-    STOP 'Cas nom prevu dans yamada4'
+     abort_message='Cas nom prevu dans yamada4'
+     CALL abort_physic(modname,abort_message,1)
 
   END IF ! Fin du cas 8
@@ -590,5 +595,5 @@
 
   IF (prt_level>1) THEN
-    PRINT *, 'YAMADA4 0'
+    WRITE(lunout,*) 'YAMADA4 0'
   END IF 
 
@@ -660,5 +665,5 @@
 
   IF (prt_level>1) THEN
-    PRINT *, 'YAMADA4 1'
+    WRITE(lunout,*)'YAMADA4 1'
   END IF !(prt_level>1) THEN
 
@@ -734,6 +739,4 @@
   IMPLICIT NONE
  
-  include "dimensions.h"
-
 !    vdif_q2: subroutine qui calcule la diffusion de la TKE par la TKE
 !             avec un schema implicite en temps avec 
@@ -825,6 +828,4 @@
   IMPLICIT NONE
 
-  include "dimensions.h"
-!
 ! vdif_q2e: subroutine qui calcule la diffusion de TKE par la TKE
 !           avec un schema explicite en temps
Index: /LMDZ6/branches/Ocean_skin/makegcm
===================================================================
--- /LMDZ6/branches/Ocean_skin/makegcm	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/makegcm	(revision 3605)
@@ -40,4 +40,5 @@
 set cosp=false
 set cosp2=false
+set cospv2=false
 set sisvat=false
 
@@ -202,4 +203,5 @@
 set lcosp=""
 set lcosp2=""
+set lcospv2=""
 set opt_dep=""
 set libchimie=""
@@ -447,4 +449,7 @@
            Pour compiler avec cosp2
 
+-cospv2 true|false
+           Pour compiler avec cospv2
+
 -filtre  filtre
            Pour choisir le filtre en longitude dans les regions polaires.
@@ -509,4 +514,6 @@
         set cosp2="$2"; shift ; shift ; goto top
 
+     case -cospv2
+        set cospv2="$2"; shift ; shift ; goto top
      case -sisvat
         set sisvat="$2" ; shift ; shift ; goto top
@@ -598,4 +605,16 @@
 endif
 
+if ( "$cospv2" == 'true' ) then
+    set cppflags="$cppflags -DCPP_COSPV2"
+    set include="$include"' -I$(LIBF)/cospv2 '
+    set opt_dep="$opt_dep cospv2"
+     set lcospv2="-lcospv2 "
+   if ( $XNEC || $X8BRODIE || $X6NEC) then
+     set lcospv2="-lsxcospv2 "
+   endif
+   set opt_link="$lcospv2 $opt_link"
+endif
+
+
 if ( "$sisvat" == 'true' ) then
     set cppflags="$cppflags -DCPP_SISVAT"
@@ -1105,4 +1124,5 @@
 L_COSP="$lcosp" \
 L_COSP2="$lcosp2" \
+L_COSPV2="$lcospv2" \
 L_CHIMIE="$libchimie" \
 LOCAL_DIR="$localdir"  \
@@ -1133,4 +1153,5 @@
 L_COSP="$lcosp" \
 L_COSP2="$lcosp2" \
+L_COSPV2="$lcospv2" \
 L_CHIMIE="$libchimie" \
 LOCAL_DIR="$localdir"  \
Index: /LMDZ6/branches/Ocean_skin/makelmdz
===================================================================
--- /LMDZ6/branches/Ocean_skin/makelmdz	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/makelmdz	(revision 3605)
@@ -26,4 +26,5 @@
 cosp=false
 cosp2=false
+cospv2=false
 sisvat=false
 rrtm=false
@@ -42,7 +43,7 @@
 ## try to recognise machine and infer arch from it
 machine=`hostname`
-if [[ "${machine:0:3}" == "ada" ]]
-then
-  arch="X64_ADA"
+if [[ "${machine:0:4}" == "jean" ]]
+then
+  arch="X64_JEANZAY"
 fi
 if [[ "${machine:0:7}" == "platine" ]]
@@ -112,4 +113,5 @@
 [-v false/orchidee2.0/orchidee1.9/true] : version of the vegetation model to include (default: false)
           false       : no vegetation model
+          orchidee2.1 : compile using ORCHIDEE 2.1 (or more recent version)
           orchidee2.0 : compile using ORCHIDEE 2.0 (or more recent version)
           orchidee1.9 : compile using ORCHIDEE up to the version including OpenMP in ORCHIDEE : tag 1.9-1.9.5(version AR5)-1.9.6
@@ -118,4 +120,5 @@
 [-cosp true/false]    : compile with/without cosp package (default: false)
 [-cosp2 true/false]    : compile with/without cosp2 package (default: false)
+[-cospv2 true/false]    : compile with/without cospv2 package (default: false)
 [-sisvat true/false]  : compile with/without sisvat package (default: false)
 [-rrtm true/false]    : compile with/without rrtm package (default: false)
@@ -183,4 +186,7 @@
       "-cosp2")
           cosp2="$2" ; shift ; shift ;;
+
+      "-cosp2")
+          cospv2="$2" ; shift ; shift ;;
       
       "-sisvat")
@@ -432,5 +438,5 @@
 
 #==============================================================================
-if [ "$veget" = "true" -o "$veget" = "orchidee1.9" -o "$veget" = "orchidee2.0" ]
+if [ "$veget" = "true" -o "$veget" = "orchidee1.9" -o "$veget" = "orchidee2.0" -o "$veget" = "orchidee2.1" ]
 then
 
@@ -442,4 +448,7 @@
    fi
    if [[ "$veget" == "orchidee2.0" ]] ; then
+      orch_libs="sechiba parameters stomate parallel orglob orchidee"
+      CPP_KEY="$CPP_KEY ORCHIDEE_NOUNSTRUCT"
+   elif [[ "$veget" == "orchidee2.1" ]] ; then
       orch_libs="sechiba parameters stomate parallel orglob orchidee"
    else
@@ -494,4 +503,11 @@
    src_dirs="$src_dirs phy${physique}/cosp2"
    INCLUDE="$INCLUDE"' -I$(LIBF)/'phy${physique}'/cosp2'
+fi
+
+if [[ "$cospv2" == "true" ]]
+then
+   CPP_KEY="$CPP_KEY CPP_COSPV2"
+   src_dirs="$src_dirs phy${physique}/cospv2"
+   INCLUDE="$INCLUDE"' -I$(LIBF)/'phy${physique}'/cospv2'
 fi
 
@@ -772,4 +788,5 @@
 L_COSP="$lcosp" \
 L_COSP2="$lcosp2" \
+L_COSPV2="$lcospv2" \
 L_CHIMIE="$libchimie" \
 LOCAL_DIR="$localdir"  \
@@ -806,4 +823,5 @@
 L_COSP="$lcosp" \
 L_COSP2="$lcosp2" \
+L_COSPV2="$lcospv2" \
 L_CHIMIE="$libchimie" \
 LOCAL_DIR="$localdir"  \
Index: /LMDZ6/branches/Ocean_skin/makelmdz_fcm
===================================================================
--- /LMDZ6/branches/Ocean_skin/makelmdz_fcm	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/makelmdz_fcm	(revision 3605)
@@ -35,4 +35,5 @@
 cosp=false
 cosp2=false
+cospv2=false
 job=1
 full=''
@@ -44,5 +45,5 @@
 
 LMDGCM=`/bin/pwd`
-LIBOGCM=$LMDGCM/libo
+LIBOGCM=$WORK/build/LMDZ_ocean_skin
 LIBFGCM=$LMDGCM/libf
 DYN_COMMON_PATH=$LIBFGCM/dyn3d_common
@@ -57,5 +58,4 @@
 SISVAT_PATH=$LMDGCM/.void_dir
 COSP_PATH=$LMDGCM/.void_dir
-COSP2_PATH=$LMDGCM/.void_dir
 fcm_path=$LMDGCM/tools/fcm/bin
 
@@ -90,5 +90,6 @@
 [-v false/orchidee2.0/orchidee1.9/true] : version of the vegetation model to include (default: false)
           false       : no vegetation model
-          orchidee2.0 : compile using ORCHIDEE 2.0 (or more recent version)
+          orchidee2.1 : compile using ORCHIDEE 2.1 (or more recent version)
+          orchidee2.0 : compile using ORCHIDEE 2.0
           orchidee1.9 : compile using ORCHIDEE up to the version including OpenMP in ORCHIDEE : tag 1.9-1.9.5(version AR5)-1.9.6
           true        : (obsolete; for backward compatibility) use ORCHIDEE tag 1.9-1.9.6
@@ -96,4 +97,5 @@
 [-cosp true/false]    : compile with/without cosp package (default: false)
 [-cosp2 true/false]    : compile with/without cosp2 package (default: false)
+[-cospv2 true/false]    : compile with/without cospv2 package (default: false)
 [-sisvat true/false]  : compile with/without sisvat package (default: false)
 [-rrtm true/false]    : compile with/without rrtm package (default: false)
@@ -181,4 +183,7 @@
       "-cosp2")
           cosp2="$2" ; shift ; shift ;;
+
+      "-cospv2")
+          cospv2="$2" ; shift ; shift ;;
       
       "-mem")
@@ -373,5 +378,5 @@
 fi
 
-if [ "$veget" = "true" -o "$veget" = "orchidee1.9" -o "$veget" = "orchidee2.0" ]
+if [ "$veget" = "true" -o "$veget" = "orchidee1.9" -o "$veget" = "orchidee2.0" -o "$veget" = "orchidee2.1" ]
 then
 #NB: option 'true': for backward compatibility. To be used with ORCHIDEE tag 1.9-1.9.6
@@ -385,4 +390,7 @@
    fi
    if [[ "$veget" == "orchidee2.0" ]] ; then
+      orch_libs="sechiba parameters stomate parallel orglob orchidee"
+      CPP_KEY="$CPP_KEY ORCHIDEE_NOUNSTRUCT"
+   elif [[ "$veget" == "orchidee2.1" ]] ; then
       orch_libs="sechiba parameters stomate parallel orglob orchidee"
    else
@@ -457,4 +465,12 @@
 #   LIB="${LIB} -l${LIBPREFIX}cosp2"
 fi
+
+if [[ "$cospv2" == "true" ]]
+then
+   CPP_KEY="$CPP_KEY CPP_COSPV2"
+   COSP_PATH="$LIBFGCM/phylmd/cospv2"
+#   LIB="${LIB} -l${LIBPREFIX}cosp2"
+fi
+
 
 
@@ -666,5 +682,4 @@
 echo "%SISVAT        $SISVAT_PATH"   >> $config_fcm
 echo "%COSP          $COSP_PATH"     >> $config_fcm
-echo "%COSP2          $COSP2_PATH"     >> $config_fcm
 echo "%CPP_KEY       $CPP_KEY"       >> $config_fcm
 echo "%EXEC          $code"          >> $config_fcm
Index: /LMDZ6/branches/Ocean_skin/tools/fcm/lib/Fcm/CfgFile.pm
===================================================================
--- /LMDZ6/branches/Ocean_skin/tools/fcm/lib/Fcm/CfgFile.pm	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/tools/fcm/lib/Fcm/CfgFile.pm	(revision 3605)
@@ -19,4 +19,5 @@
 # Standard pragma
 use warnings;
+no warnings 'uninitialized';
 use strict;
 
